<?php
/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package interior_services
 */

function interior_services_body_classes( $interior_services_classes ) {
	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$interior_services_classes[] = 'hfeed';
	}

	// Adds a class of no-sidebar when there is no sidebar present.
	if ( ! is_active_sidebar( 'sidebar-1' ) ) {
		$interior_services_classes[] = 'no-sidebar';
	}

	$interior_services_classes[] = interior_services_sidebar_layout();

	return $interior_services_classes;
}
add_filter( 'body_class', 'interior_services_body_classes' );

/**
 * Add a pingback url auto-discovery header for single posts, pages, or attachments.
 */
function interior_services_pingback_header() {
	if ( is_singular() && pings_open() ) {
		printf( '<link rel="pingback" href="%s">', esc_url( get_bloginfo( 'pingback_url' ) ) );
	}
}
add_action( 'wp_head', 'interior_services_pingback_header' );


/**
 * Get all posts for customizer Post content type.
 */
function interior_services_get_post_choices() {
	$interior_services_choices = array( '' => esc_html__( '--Select--', 'interior-services' ) );
	$interior_services_args    = array( 'numberposts' => -1 );
	$interior_services_posts   = get_posts( $interior_services_args );

	foreach ( $interior_services_posts as $interior_services_post ) {
		$interior_services_id             = $interior_services_post->ID;
		$interior_services_title          = $interior_services_post->post_title;
		$interior_services_choices[ $interior_services_id ] = $interior_services_title;
	}

	return $interior_services_choices;
}

/**
 * Get all pages for customizer Page content type.
 */
function interior_services_get_page_choices() {
	$interior_services_choices = array( '' => esc_html__( '--Select--', 'interior-services' ) );
	$interior_services_pages   = get_pages();

	foreach ( $interior_services_pages as $interior_services_page ) {
		$interior_services_choices[ $interior_services_page->ID ] = $interior_services_page->post_title;
	}

	return $interior_services_choices;
}

/**
 * Get all categories for customizer Category content type.
 */
function interior_services_get_post_cat_choices() {
	$interior_services_choices = array( '' => esc_html__( '--Select--', 'interior-services' ) );
	$interior_services_cats    = get_categories();

	foreach ( $interior_services_cats as $interior_services_cat ) {
		$interior_services_choices[ $interior_services_cat->term_id ] = $interior_services_cat->name;
	}

	return $interior_services_choices;
}

/**
 * Get all donation forms for customizer form content type.
 */
function interior_services_get_post_donation_form_choices() {
	$interior_services_choices = array( '' => esc_html__( '--Select--', 'interior-services' ) );
	$interior_services_posts   = get_posts(
		array(
			'post_type'   => 'give_forms',
			'numberposts' => -1,
		)
	);
	foreach ( $interior_services_posts as $interior_services_post ) {
		$interior_services_choices[ $interior_services_post->ID ] = $interior_services_post->post_title;
	}
	return $interior_services_choices;
}

if ( ! function_exists( 'interior_services_excerpt_length' ) ) :
	/**
	 * Excerpt length.
	 */
	function interior_services_excerpt_length( $interior_services_length ) {
		if ( is_admin() ) {
			return $interior_services_length;
		}

		return get_theme_mod( 'interior_services_excerpt_length', 20 );
	}
endif;
add_filter( 'excerpt_length', 'interior_services_excerpt_length', 999 );

if ( ! function_exists( 'interior_services_excerpt_more' ) ) :
	/**
	 * Excerpt more.
	 */
	function interior_services_excerpt_more( $interior_services_more ) {
		if ( is_admin() ) {
			return $interior_services_more;
		}

		return '&hellip;';
	}
endif;
add_filter( 'excerpt_more', 'interior_services_excerpt_more' );

if ( ! function_exists( 'interior_services_sidebar_layout' ) ) {
	/**
	 * Get sidebar layout.
	 */
	function interior_services_sidebar_layout() {
		$interior_services_sidebar_position      = get_theme_mod( 'interior_services_sidebar_position', 'right-sidebar' );
		$interior_services_sidebar_position_post = get_theme_mod( 'interior_services_post_sidebar_position', 'right-sidebar' );
		$interior_services_sidebar_position_page = get_theme_mod( 'interior_services_page_sidebar_position', 'right-sidebar' );

		if ( is_home() ) {
			$interior_services_sidebar_position = $interior_services_sidebar_position_post;
		} elseif ( is_page() ) {
			$interior_services_sidebar_position = $interior_services_sidebar_position_page;
		}

		return $interior_services_sidebar_position;
	}
}

if ( ! function_exists( 'interior_services_is_sidebar_enabled' ) ) {
	/**
	 * Check if sidebar is enabled.
	 */
	function interior_services_is_sidebar_enabled() {
		$interior_services_sidebar_position      = get_theme_mod( 'interior_services_sidebar_position', 'right-sidebar' );
		$interior_services_sidebar_position_post = get_theme_mod( 'interior_services_post_sidebar_position', 'right-sidebar' );
		$interior_services_sidebar_position_page = get_theme_mod( 'interior_services_page_sidebar_position', 'right-sidebar' );

		$interior_services_sidebar_enabled = true;
		if ( is_single() || is_archive() || is_search() ) {
			if ( 'no-sidebar' === $interior_services_sidebar_position ) {
				$interior_services_sidebar_enabled = false;
			}
		} elseif ( is_home() ) {
			if ( 'no-sidebar' === $interior_services_sidebar_position || 'no-sidebar' === $interior_services_sidebar_position_post ) {
				$interior_services_sidebar_enabled = false;
			}
		} elseif ( is_page() ) {
			if ( 'no-sidebar' === $interior_services_sidebar_position || 'no-sidebar' === $interior_services_sidebar_position_page ) {
				$interior_services_sidebar_enabled = false;
			}
		}
		return $interior_services_sidebar_enabled;
	}
}

if ( ! function_exists( 'interior_services_get_homepage_sections ' ) ) {
	/**
	 * Returns homepage sections.
	 */
	function interior_services_get_homepage_sections() {
		$interior_services_sections = array(
			'slider'  => esc_html__( 'Slider Section', 'interior-services' ),
			'services' => esc_html__( 'Services Section', 'interior-services' ),
		);
		return $interior_services_sections;
	}
}

/**
 * Renders customizer section link
 */
function interior_services_section_link( $interior_services_section_id ) {
	$interior_services_section_name      = str_replace( 'interior_services_', ' ', $interior_services_section_id );
	$interior_services_section_name      = str_replace( '_', ' ', $interior_services_section_name );
	$interior_services_starting_notation = '#';
	?>
	<span class="section-link">
		<span class="section-link-title"><?php echo esc_html( $interior_services_section_name ); ?></span>
	</span>
	<style type="text/css">
		<?php echo $interior_services_starting_notation . $interior_services_section_id; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>:hover .section-link {
			visibility: visible;
		}
	</style>
	<?php
}

/**
 * Adds customizer section link css
 */
function interior_services_section_link_css() {
	if ( is_customize_preview() ) {
		?>
		<style type="text/css">
			.section-link {
				visibility: hidden;
				background-color: black;
				position: relative;
				top: 80px;
				z-index: 99;
				left: 40px;
				color: #fff;
				text-align: center;
				font-size: 20px;
				border-radius: 10px;
				padding: 20px 10px;
				text-transform: capitalize;
			}

			.section-link-title {
				padding: 0 10px;
			}

			.slider-section {
				position: relative;
			}

			.slider-section .section-link {
				position: absolute;
				top: 100px;
			}
		</style>
		<?php
	}
}
add_action( 'wp_head', 'interior_services_section_link_css' );

/**
 * Breadcrumb.
 */
function interior_services_breadcrumb( $interior_services_args = array() ) {
	if ( ! get_theme_mod( 'interior_services_enable_breadcrumb', true ) ) {
		return;
	}

	$interior_services_args = array(
		'show_on_front' => false,
		'show_title'    => true,
		'show_browse'   => false,
	);
	breadcrumb_trail( $interior_services_args );
}
add_action( 'interior_services_breadcrumb', 'interior_services_breadcrumb', 10 );

/**
 * Add separator for breadcrumb trail.
 */
function interior_services_breadcrumb_trail_print_styles() {
	$interior_services_breadcrumb_separator = get_theme_mod( 'interior_services_breadcrumb_separator', '/' );

	$interior_services_style = '
		.trail-items li::after {
			content: "' . $interior_services_breadcrumb_separator . '";
		}'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	$interior_services_style = apply_filters( 'interior_services_breadcrumb_trail_inline_style', trim( str_replace( array( "\r", "\n", "\t", '  ' ), '', $interior_services_style ) ) );

	if ( $interior_services_style ) {
		echo "\n" . '<style type="text/css" id="breadcrumb-trail-css">' . $interior_services_style . '</style>' . "\n"; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
}
add_action( 'wp_head', 'interior_services_breadcrumb_trail_print_styles' );

/**
 * Pagination for archive.
 */
function interior_services_render_posts_pagination() {
	$interior_services_is_pagination_enabled = get_theme_mod( 'interior_services_enable_pagination', true );
	if ( $interior_services_is_pagination_enabled ) {
		$interior_services_pagination_type = get_theme_mod( 'interior_services_pagination_type', 'default' );
		if ( 'default' === $interior_services_pagination_type ) :
			the_posts_navigation();
		else :
			the_posts_pagination();
		endif;
	}
}
add_action( 'interior_services_posts_pagination', 'interior_services_render_posts_pagination', 10 );

/**
 * Pagination for single post.
 */
function interior_services_render_post_navigation() {
	the_post_navigation(
		array(
			'prev_text' => '<span>&#10229;</span> <span class="nav-title">%title</span>',
			'next_text' => '<span class="nav-title">%title</span> <span>&#10230;</span>',
		)
	);
}
add_action( 'interior_services_post_navigation', 'interior_services_render_post_navigation' );

/**
 * Adds footer copyright text.
 */
function interior_services_output_footer_copyright_content() {
    $interior_services_theme_data = wp_get_theme();
    $interior_services_copyright_text = get_theme_mod('interior_services_footer_copyright_text');

	if (!empty($interior_services_copyright_text)) {
        $interior_services_text = $interior_services_copyright_text;
    } else {

		$interior_services_default_text = '<a href="'. esc_url(__('https://asterthemes.com/products/interior-services','interior-services')) . '" target="_blank"> ' . esc_html($interior_services_theme_data->get('Name')) . '</a>' . '&nbsp;' . esc_html__('by', 'interior-services') . '&nbsp;<a target="_blank" href="' . esc_url($interior_services_theme_data->get('AuthorURI')) . '">' . esc_html(ucwords($interior_services_theme_data->get('Author'))) . '</a>';
		/* translators: %s: WordPress.org URL */
        $interior_services_default_text .= sprintf(esc_html__(' | Powered by %s', 'interior-services'), '<a href="' . esc_url(__('https://wordpress.org/', 'interior-services')) . '" target="_blank">WordPress</a>. ');

        $interior_services_text = $interior_services_default_text;

    }
    ?>
    <span><?php echo wp_kses_post($interior_services_text); ?></span>
    <?php
}
add_action('interior_services_footer_copyright', 'interior_services_output_footer_copyright_content');

/* Footer Social Icons */ 
function interior_services_footer_social_links() {

    if ( get_theme_mod('interior_services_enable_footer_icon_section', true) ) {

            ?>
            <div class="socialicons">
				<div class="asterthemes-wrapper">
					<?php if ( get_theme_mod('interior_services_footer_facebook_link', 'https://www.facebook.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('interior_services_footer_facebook_link', 'https://www.facebook.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('interior_services_facebook_icon', 'fab fa-facebook-f')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Facebook', 'interior-services'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('interior_services_footer_twitter_link', 'https://x.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('interior_services_footer_twitter_link', 'https://x.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('interior_services_twitter_icon', 'fab fa-twitter')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Twitter', 'interior-services'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('interior_services_footer_instagram_link', 'https://www.instagram.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('interior_services_footer_instagram_link', 'https://www.instagram.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('interior_services_instagram_icon', 'fab fa-instagram')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Instagram', 'interior-services'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('interior_services_footer_linkedin_link', 'https://in.linkedin.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('interior_services_footer_linkedin_link', 'https://in.linkedin.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('interior_services_linkedin_icon', 'fab fa-linkedin')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Linkedin', 'interior-services'); ?></span>
						</a>
					<?php } ?>
					<?php if ( get_theme_mod('interior_services_footer_youtube_link', 'https://www.youtube.com/') != '' ) { ?>
						<a target="_blank" href="<?php echo esc_url(get_theme_mod('interior_services_footer_youtube_link', 'https://www.youtube.com/')); ?>">
							<i class="<?php echo esc_attr(get_theme_mod('interior_services_youtube_icon', 'fab fa-youtube')); ?>"></i>
							<span class="screen-reader-text"><?php esc_html_e('Youtube', 'interior-services'); ?></span>
						</a>
					<?php } ?>
				</div>
            </div>
            <?php
    }
}
add_action('wp_footer', 'interior_services_footer_social_links');

if ( ! function_exists( 'interior_services_footer_widget' ) ) :
	function interior_services_footer_widget() {
		$interior_services_footer_widget_column = get_theme_mod('interior_services_footer_widget_column','4');

		$interior_services_column_class = '';
		if ($interior_services_footer_widget_column == '1') {
			$interior_services_column_class = 'one-column';
		} elseif ($interior_services_footer_widget_column == '2') {
			$interior_services_column_class = 'two-columns';
		} elseif ($interior_services_footer_widget_column == '3') {
			$interior_services_column_class = 'three-columns';
		} else {
			$interior_services_column_class = 'four-columns';
		}
	
		if($interior_services_footer_widget_column !== ''): 
		?>
		<div class="dt_footer-widgets <?php echo esc_attr($interior_services_column_class); ?>  wow bounceInUp delay-1000" data-wow-duration="2s">
			<div class="footer-widgets-column">
				<?php
				$footer_widgets_active = false;

				// Loop to check if any footer widget is active
				for ($interior_services_i = 1; $interior_services_i <= $interior_services_footer_widget_column; $interior_services_i++) {
					if (is_active_sidebar('footer-widget-' . $interior_services_i)) {
						$footer_widgets_active = true;
						break;
					}
				}

				if ($footer_widgets_active) {
					// Display active footer widgets
					for ($interior_services_i = 1; $interior_services_i <= $interior_services_footer_widget_column; $interior_services_i++) {
						if (is_active_sidebar('footer-widget-' . $interior_services_i)) : ?>
							<div class="footer-one-column">
								<?php dynamic_sidebar('footer-widget-' . $interior_services_i); ?>
							</div>
						<?php endif;
					}
				} else {
				?>
				<div class="footer-one-column default-widgets">
					<aside id="search-2" class="widget widget_search default_footer_search">
						<div class="widget-header">
							<h4 class="widget-title"><?php esc_html_e('Search Here', 'interior-services'); ?></h4>
						</div>
						<?php get_search_form(); ?>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-posts-2" class="widget widget_recent_entries">
						<h2 class="widget-title"><?php esc_html_e('Recent Posts', 'interior-services'); ?></h2>
						<ul>
							<?php
							$recent_posts = wp_get_recent_posts(array(
								'numberposts' => 5,
								'post_status' => 'publish',
							));
							foreach ($recent_posts as $post) {
								echo '<li><a href="' . esc_url(get_permalink($post['ID'])) . '">' . esc_html($post['post_title']) . '</a></li>';
							}
							wp_reset_query();
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-comments-2" class="widget widget_recent_comments">
						<h2 class="widget-title"><?php esc_html_e('Recent Comments', 'interior-services'); ?></h2>
						<ul>
							<?php
							$recent_comments = get_comments(array(
								'number' => 5,
								'status' => 'approve',
							));
							foreach ($recent_comments as $comment) {
								echo '<li><a href="' . esc_url(get_comment_link($comment)) . '">' .
									/* translators: %s: details. */
									sprintf(esc_html__('Comment on %s', 'interior-services'), get_the_title($comment->comment_post_ID)) .
									'</a></li>';
							}
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="categories" class="widget py-3" role="complementary" aria-label="<?php esc_attr_e('footer1', 'interior-services'); ?>">
                        <h3 class="widget-title"><?php esc_html_e('Categories', 'interior-services'); ?></h3>
                        <ul>
                            <?php wp_list_categories('title_li='); ?>
                        </ul>
                    </aside>
				</div>
			</div>
			<?php } ?>
		</div>
		<?php
		endif;
	}
	endif;
add_action( 'interior_services_footer_widget', 'interior_services_footer_widget' );


function interior_services_footer_text_transform_css() {
    $interior_services_footer_text_transform = get_theme_mod('footer_text_transform', 'none');
    ?>
    <style type="text/css">
        .site-footer h4,footer#colophon h2.wp-block-heading,footer#colophon .widgettitle,footer#colophon .widget-title {
            text-transform: <?php echo esc_html($interior_services_footer_text_transform); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'interior_services_footer_text_transform_css');

/**
 * GET START FUNCTION
 */

 function interior_services_getpage_css($hook) {
	wp_enqueue_script( 'interior-services-admin-script', get_template_directory_uri() . '/resource/js/interior-services-admin-notice-script.js', array( 'jquery' ) );
    wp_localize_script( 'interior-services-admin-script', 'interior_services_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
    wp_enqueue_style( 'interior-services-notice-style', get_template_directory_uri() . '/resource/css/notice.css' );
}

add_action( 'admin_enqueue_scripts', 'interior_services_getpage_css' );

add_action('wp_ajax_interior_services_dismissable_notice', 'interior_services_dismissable_notice');
function interior_services_switch_theme() {
    delete_user_meta(get_current_user_id(), 'interior_services_dismissable_notice');
}
add_action('after_switch_theme', 'interior_services_switch_theme');
function interior_services_dismissable_notice() {
    update_user_meta(get_current_user_id(), 'interior_services_dismissable_notice', true);
    die();
}

function interior_services_deprecated_hook_admin_notice() {
    global $pagenow;
    
    // Check if the current page is the one where you don't want the notice to appear
    if ( $pagenow === 'themes.php' && isset( $_GET['page'] ) && $_GET['page'] === 'interior-services-getting-started' ) {
        return;
    }

    $dismissed = get_user_meta( get_current_user_id(), 'interior_services_dismissable_notice', true );
    if ( !$dismissed) { ?>
        <div class="getstrat updated notice notice-success is-dismissible notice-get-started-class">
            <div class="at-admin-content" >
                <h2><?php esc_html_e('Welcome to Interior Services', 'interior-services'); ?></h2>
                <p><?php _e('Explore the features of our Pro Theme and take your Interior Services journey to the next level.', 'interior-services'); ?></p>
                <p ><?php _e('Get Started With Theme By Clicking On Getting Started.', 'interior-services'); ?><p>
                <div style="display: flex; justify-content: center; align-items:center; flex-wrap: wrap; gap: 5px">
                    <a class="admin-notice-btn button button-primary button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=interior-services-getting-started' )); ?>"><?php esc_html_e( 'Get started', 'interior-services' ) ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="https://demo.asterthemes.com/interior-services/"><?php esc_html_e('View Demo', 'interior-services') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( INTERIOR_SERVICES_PREMIUM_PAGE ); ?>"><?php esc_html_e('Buy Now', 'interior-services') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( INTERIOR_SERVICES_BUNDLE_PAGE ); ?>"><?php esc_html_e('Get Bundle', 'interior-services') ?></a>
                </div>
            </div>
            <div class="at-admin-image">
                <img style="width: 100%;max-width: 320px;line-height: 40px;display: inline-block;vertical-align: top;border: 2px solid #ddd;border-radius: 4px;" src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
            </div>
        </div>
    <?php }
}
add_action( 'admin_notices', 'interior_services_deprecated_hook_admin_notice' );


//Admin Notice For Getstart
function interior_services_ajax_notice_handler() {
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}